diff --git a/src/main/java/net/minecraft/client/render/model/ModelWolf.java b/src/main/java/net/minecraft/client/render/model/WolfModel.java
similarity index 63%
rename from src/main/java/net/minecraft/client/render/model/ModelWolf.java
rename to src/main/java/net/minecraft/client/render/model/WolfModel.java
index 1e0ac5784..d2898284a 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelWolf.java
+++ b/src/main/java/net/minecraft/client/render/model/WolfModel.java
@@ -1,21 +1,20 @@
 package net.minecraft.client.render.model;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.core.Global;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.animal.EntityWolf;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.WolfMob;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            ModelBase, ModelRenderer, EntityWolf, MathHelper, 
-//            EntityLiving
+//            BaseModel, ModelRenderer, WolfMob, MathHelper,
+//            Mob
 
-public class ModelWolf extends ModelBase
+public class WolfModel extends BaseModel
 {
 
-    public ModelWolf(float expandAmount)
+    public WolfModel(float expandAmount)
     {
         float f1 = 13.5F;
         wolfHeadMain = new Cube(0, 0);
@@ -57,7 +56,7 @@ public class ModelWolf extends ModelBase
     public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
         super.render(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
-        setRotationAngles(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
         wolfHeadMain.renderWithRotation(scale);
         wolfBody.render(scale);
         wolfLeg1.render(scale);
@@ -72,56 +71,56 @@ public class ModelWolf extends ModelBase
     }
 
     @Override
-    public void setLivingAnimations(EntityLiving entityliving, float limbSwing, float limbYaw, float partialTick)
+    public void setLivingAnimations(Mob mob, float limbSwing, float limbYaw, float partialTick)
     {
-        EntityWolf entitywolf = (EntityWolf)entityliving;
+        WolfMob entitywolf = (WolfMob) mob;
         if(entitywolf.isWolfAngry())
         {
-            wolfTail.rotateAngleY = 0.0F;
+            wolfTail.yRot = 0.0F;
         } else
         {
-            wolfTail.rotateAngleY = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+            wolfTail.yRot = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
         }
         if(entitywolf.isWolfSitting())
         {
             wolfMane.setRotationPoint(-1F, 16F, -3F);
-            wolfMane.rotateAngleX = 1.256637F;
-            wolfMane.rotateAngleY = 0.0F;
+            wolfMane.xRot = 1.256637F;
+            wolfMane.yRot = 0.0F;
             wolfBody.setRotationPoint(0.0F, 18F, 0.0F);
-            wolfBody.rotateAngleX = 0.7853982F;
+            wolfBody.xRot = 0.7853982F;
             wolfTail.setRotationPoint(-1F, 21F, 6F);
             wolfLeg1.setRotationPoint(-2.5F, 22F, 2.0F);
-            wolfLeg1.rotateAngleX = 4.712389F;
+            wolfLeg1.xRot = MathHelper.PI * 1.5F;
             wolfLeg2.setRotationPoint(0.5F, 22F, 2.0F);
-            wolfLeg2.rotateAngleX = 4.712389F;
-            wolfLeg3.rotateAngleX = 5.811947F;
+            wolfLeg2.xRot = MathHelper.PI * 1.5F;
+            wolfLeg3.xRot = 5.811947F;
             wolfLeg3.setRotationPoint(-2.49F, 17F, -4F);
-            wolfLeg4.rotateAngleX = 5.811947F;
+            wolfLeg4.xRot = 5.811947F;
             wolfLeg4.setRotationPoint(0.51F, 17F, -4F);
         } else
         {
             wolfBody.setRotationPoint(0.0F, 14F, 2.0F);
-            wolfBody.rotateAngleX = 1.570796F;
+            wolfBody.xRot = MathHelper.PI / 2F;
             wolfMane.setRotationPoint(-1F, 14F, -3F);
-            wolfMane.rotateAngleX = wolfBody.rotateAngleX;
+            wolfMane.xRot = wolfBody.xRot;
             wolfTail.setRotationPoint(-1F, 12F, 8F);
             wolfLeg1.setRotationPoint(-2.5F, 16F, 7F);
             wolfLeg2.setRotationPoint(0.5F, 16F, 7F);
             wolfLeg3.setRotationPoint(-2.5F, 16F, -4F);
             wolfLeg4.setRotationPoint(0.5F, 16F, -4F);
-            wolfLeg1.rotateAngleX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
-            wolfLeg2.rotateAngleX = MathHelper.cos(limbSwing * 0.6662F + 3.141593F) * 1.4F * limbYaw;
-            wolfLeg3.rotateAngleX = MathHelper.cos(limbSwing * 0.6662F + 3.141593F) * 1.4F * limbYaw;
-            wolfLeg4.rotateAngleX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+            wolfLeg1.xRot = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+            wolfLeg2.xRot = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+            wolfLeg3.xRot = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+            wolfLeg4.xRot = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
         }
         float f3 = entitywolf.getInterestedAngle(partialTick) + entitywolf.getShakeAngle(partialTick, 0.0F);
-        wolfHeadMain.rotateAngleZ = f3;
-        wolfRightEar.rotateAngleZ = f3;
-        wolfLeftEar.rotateAngleZ = f3;
-        wolfSnout.rotateAngleZ = f3;
-        wolfMane.rotateAngleZ = entitywolf.getShakeAngle(partialTick, -0.08F);
-        wolfBody.rotateAngleZ = entitywolf.getShakeAngle(partialTick, -0.16F);
-        wolfTail.rotateAngleZ = entitywolf.getShakeAngle(partialTick, -0.2F);
+        wolfHeadMain.zRot = f3;
+        wolfRightEar.zRot = f3;
+        wolfLeftEar.zRot = f3;
+        wolfSnout.zRot = f3;
+        wolfMane.zRot = entitywolf.getShakeAngle(partialTick, -0.08F);
+        wolfBody.zRot = entitywolf.getShakeAngle(partialTick, -0.16F);
+        wolfTail.zRot = entitywolf.getShakeAngle(partialTick, -0.2F);
 
         if(entitywolf.getWolfShaking())
         {
@@ -139,18 +138,18 @@ public class ModelWolf extends ModelBase
     }
 
     @Override
-    public void setRotationAngles(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
-        super.setRotationAngles(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
-        wolfHeadMain.rotateAngleX = headPitch / 57.29578F;
-        wolfHeadMain.rotateAngleY = headYaw / 57.29578F;
-        wolfRightEar.rotateAngleY = wolfHeadMain.rotateAngleY;
-        wolfRightEar.rotateAngleX = wolfHeadMain.rotateAngleX;
-        wolfLeftEar.rotateAngleY = wolfHeadMain.rotateAngleY;
-        wolfLeftEar.rotateAngleX = wolfHeadMain.rotateAngleX;
-        wolfSnout.rotateAngleY = wolfHeadMain.rotateAngleY;
-        wolfSnout.rotateAngleX = wolfHeadMain.rotateAngleX;
-        wolfTail.rotateAngleX = limbPitch;
+        super.setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        wolfHeadMain.xRot = headPitch / 57.29578F;
+        wolfHeadMain.yRot = headYaw / 57.29578F;
+        wolfRightEar.yRot = wolfHeadMain.yRot;
+        wolfRightEar.xRot = wolfHeadMain.xRot;
+        wolfLeftEar.yRot = wolfHeadMain.yRot;
+        wolfLeftEar.xRot = wolfHeadMain.xRot;
+        wolfSnout.yRot = wolfHeadMain.yRot;
+        wolfSnout.xRot = wolfHeadMain.xRot;
+        wolfTail.xRot = limbPitch;
     }
 
     public Cube wolfHeadMain;
diff --git a/src/main/java/net/minecraft/client/render/model/ZombieModel.java b/src/main/java/net/minecraft/client/render/model/ZombieModel.java
new file mode 100644
index 000000000..279401957
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/model/ZombieModel.java
@@ -0,0 +1,75 @@
+package net.minecraft.client.render.model;
+
+
+// Referenced classes of package net.minecraft.src:
+//            BipedModel, MathHelper, ModelRenderer
+
+import net.minecraft.core.util.helper.MathHelper;
+
+public class ZombieModel extends BipedModel {
+    public ZombieModel() {
+        this(0.0F);
+    }
+
+    public ZombieModel(float var1) {
+        this.parts(var1, 0.0F);
+    }
+
+    public void parts(float var1, float var2) {
+        this.holdingLeftHand = false;
+        this.holdingRightHand = false;
+        this.sneaking = false;
+        this.cloak = new Cube(0, 0);
+        this.cloak.addBox(-5.0F, 0.0F, -1.0F, 10, 16, 1, var1);
+        this.ear = new Cube(24, 0);
+        this.ear.addBox(-4.0F, -7.0F, -1.0F, 7, 7, 1, var1);
+        this.head = new Cube(0, 0);
+        this.head.addBox(-4.0F, -8.0F, -4.0F, 8, 8, 8, var1);
+        this.head.setRotationPoint(0.0F, 0.0F + var2, 0.0F);
+        this.hair = new Cube(32, 0);
+        this.hair.addBox(-4.0F, -8.0F, -4.0F, 8, 8, 8, var1 + 0.5F);
+        this.hair.setRotationPoint(0.0F, 0.0F + var2, 0.0F);
+        this.body = new Cube(16, 16);
+        this.body.addBox(-4.0F, 0.0F, -2.0F, 8, 12, 4, var1);
+        this.body.setRotationPoint(0.0F, 0.0F + var2, 0.0F);
+        this.arm0 = new Cube(40, 16);
+        this.arm0.addBox(-3.0F, -2.0F, -2.0F, 4, 12, 4, var1);
+        this.arm0.setRotationPoint(-5.0F, 2.0F + var2, 0.0F);
+        this.arm1 = new Cube(40, 16);
+        this.arm1.mirror = true;
+        this.arm1.addBox(-1.0F, -2.0F, -2.0F, 4, 12, 4, var1);
+        this.arm1.setRotationPoint(5.0F, 2.0F + var2, 0.0F);
+        this.leg0 = new Cube(0, 16);
+        this.leg0.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, var1);
+        this.leg0.setRotationPoint(-2.0F, 12.0F + var2, 0.0F);
+        this.leg1 = new Cube(0, 16);
+        this.leg1.mirror = true;
+        this.leg1.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, var1);
+        this.leg1.setRotationPoint(2.0F, 12.0F + var2, 0.0F);
+    }
+
+    @Override
+    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale) {
+        super.setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        float var7 = MathHelper.sin(this.onGround * 3.1415927F);
+        float var8 = MathHelper.sin((1.0F - (1.0F - this.onGround) * (1.0F - this.onGround)) * 3.1415927F);
+        this.arm0.zRot = 0.0F;
+        this.arm1.zRot = 0.0F;
+        this.arm0.yRot = -(0.1F - var7 * 0.6F);
+        this.arm1.yRot = 0.1F - var7 * 0.6F;
+        this.arm0.xRot = -1.5707964F;
+        this.arm1.xRot = -1.5707964F;
+        Cube var10000 = this.arm0;
+        var10000.xRot -= var7 * 1.2F - var8 * 0.4F;
+        var10000 = this.arm1;
+        var10000.xRot -= var7 * 1.2F - var8 * 0.4F;
+        var10000 = this.arm0;
+        var10000.zRot += MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        var10000 = this.arm1;
+        var10000.zRot -= MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        var10000 = this.arm0;
+        var10000.xRot += MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+        var10000 = this.arm1;
+        var10000.xRot -= MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+    }
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java b/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
index 7f67c2414..8f1773f20 100644
--- a/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
+++ b/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
@@ -16,7 +16,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Framebuffer;
 import net.minecraft.client.render.OpenGLHelper;
 import net.minecraft.client.render.Renderer;
-import net.minecraft.client.render.Texture;
+import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.material.Material;
@@ -119,7 +119,7 @@ public class ShadersRenderer implements Renderer {
 			
 			// Read projection matrix, invert it, and send it to the shader
 			matrixBuffer.clear();
-			glGetFloat(GL_PROJECTION_MATRIX, matrixBuffer);
+			glGetFloatv(GL_PROJECTION_MATRIX, matrixBuffer);
 			
 			matrixBuffer.position(0);
 			matrix.load(matrixBuffer);
@@ -131,7 +131,7 @@ public class ShadersRenderer implements Renderer {
 			
 			matrixBuffer.position(0);
 			matrixBuffer.limit(16);
-			glUniformMatrix4(cloudsShader.getUniform("gbufferProjectionInverse"), false, matrixBuffer);
+			glUniformMatrix4fv(cloudsShader.getUniform("gbufferProjectionInverse"), false, matrixBuffer);
 			
 			int isEyeInLiquid;
 			if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.theWorld, Material.lava, partialTicks)) {
@@ -196,7 +196,7 @@ public class ShadersRenderer implements Renderer {
 
 	public void setupFramebuffer() {
 		double renderScale = (float) mc.gameSettings.renderScale.value.scale;
-		
+
 		int scaledWidth = (int) (renderScale * mc.resolution.width);
 		int scaledHeight = (int) (renderScale * mc.resolution.height);
 		
diff --git a/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java b/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java
index 958b64dd7..1110cca62 100644
--- a/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java
+++ b/src/main/java/net/minecraft/client/render/tessellator/TessellatorStandard.java
@@ -7,6 +7,7 @@ import java.nio.ByteBuffer;
 import java.nio.ByteOrder;
 
 import net.minecraft.core.util.helper.MathHelper;
+import org.lwjgl.opengl.GL11;
 
 public class TessellatorStandard extends TessellatorBase {
 
@@ -85,7 +86,7 @@ public class TessellatorStandard extends TessellatorBase {
 		if(hasColor) {
 			glEnableClientState(GL_COLOR_ARRAY);
 			buffer.position(offset);
-			glColorPointer(4, true, vertexSize, buffer);
+			glColorPointer(4, GL_UNSIGNED_BYTE, vertexSize, buffer);
 			offset += 4;
 		}else {
 			glDisableClientState(GL_COLOR_ARRAY);
diff --git a/src/main/java/net/minecraft/client/render/texture/BufferedTexture.java b/src/main/java/net/minecraft/client/render/texture/BufferedTexture.java
new file mode 100644
index 000000000..260a00a17
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/texture/BufferedTexture.java
@@ -0,0 +1,29 @@
+package net.minecraft.client.render.texture;
+
+import java.awt.image.BufferedImage;
+
+public class BufferedTexture extends FileTexture{
+    protected BufferedImage image;
+
+    protected boolean blur;
+    protected boolean clamp;
+    protected boolean mipmap;
+
+    public BufferedTexture(BufferedImage image, boolean blur, boolean clamp, boolean mipmap) {
+        generate();
+        this.blur = blur;
+        this.clamp = clamp;
+        this.mipmap = mipmap;
+        this.image = image;
+        init();
+    }
+
+    @Override
+    public void init() {
+        setupTexture(image, blur, clamp, mipmap);
+    }
+
+    public BufferedImage getBufferedImage() {
+        return image;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/texture/DownloadedTexture.java b/src/main/java/net/minecraft/client/render/texture/DownloadedTexture.java
new file mode 100644
index 000000000..61895d88f
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/texture/DownloadedTexture.java
@@ -0,0 +1,18 @@
+package net.minecraft.client.render.texture;
+
+import net.minecraft.client.net.thread.ThreadDownloadImage;
+import net.minecraft.client.render.ImageParser;
+
+import java.awt.image.BufferedImage;
+
+public class DownloadedTexture extends FileTexture {
+
+	public BufferedImage image;
+	public int referenceCount;
+
+	public DownloadedTexture(String url, ImageParser imageParser) {
+		referenceCount = 1;
+		
+		new ThreadDownloadImage(this, url, imageParser).start();
+	}
+}
diff --git a/src/main/java/net/minecraft/client/render/texture/FileTexture.java b/src/main/java/net/minecraft/client/render/texture/FileTexture.java
new file mode 100644
index 000000000..4922c53e3
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/texture/FileTexture.java
@@ -0,0 +1,85 @@
+package net.minecraft.client.render.texture;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.texture.meta.TextureMetaHandler;
+import net.minecraft.client.render.texturepack.TexturePack;
+import org.jetbrains.annotations.Nullable;
+
+import java.io.IOException;
+import java.io.InputStream;
+
+import static net.minecraft.client.util.helper.Textures.missingTexture;
+import static net.minecraft.client.util.helper.Textures.readImage;
+
+public class FileTexture extends Texture{
+
+    protected final String sourcePath;
+
+    protected TextureMetaHandler metaHandler = new TextureMetaHandler();
+
+    public FileTexture() {
+        this.sourcePath = null;
+    }
+
+    public FileTexture(String path) {
+        generate();
+        this.sourcePath = path;
+        init();
+    }
+
+    @Override
+    public boolean hasMeta(String key) {
+        return metaHandler.has(key);
+    }
+
+    @Override
+    public @Nullable <T> T getMeta(String key, Class<T> aClass) {
+        return metaHandler.get(key, aClass);
+    }
+
+    @Override
+    public <T> T getOrDefaultMeta(String key, T metaDefault, Class<T> aClass) {
+        return metaHandler.getOrDefault(key, metaDefault, aClass);
+    }
+
+    @Override
+    public void init() {
+        metaHandler.reset();
+
+        if (sourcePath != null) {
+            Minecraft mc = Minecraft.getMinecraft(this);
+            TexturePack pack = mc.texturePackList.getHighestPriorityTexturePackWithFile(sourcePath);
+            if (pack == null) {
+                setupTexture(missingTexture);
+                return;
+            }
+
+            try (InputStream stream = pack.getResourceAsStream(sourcePath + ".mcmeta")) {
+                if (stream != null) {
+                    metaHandler.loadFromStream(stream);
+                }
+            } catch (Exception e) {
+                e.printStackTrace();
+            }
+
+            try (InputStream imageStream = pack.getResourceAsStream(sourcePath)) {
+                if (imageStream == null) {
+                    setupTexture(missingTexture);
+                    return;
+                }
+                setupTexture(readImage(imageStream));
+            } catch (IOException e) {
+                setupTexture(missingTexture);
+            }
+        }
+    }
+
+    @Override
+    public String toString() {
+        StringBuilder builder = new StringBuilder();
+        builder.append("Source: ").append(sourcePath).append("\n");
+        builder.append("Meta: \n").append(metaHandler);
+        return builder.toString();
+    }
+
+}
diff --git a/src/main/java/net/minecraft/client/render/texture/Texture.java b/src/main/java/net/minecraft/client/render/texture/Texture.java
new file mode 100644
index 000000000..86b753d83
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/texture/Texture.java
@@ -0,0 +1,298 @@
+package net.minecraft.client.render.texture;
+
+import static net.minecraft.core.util.helper.Buffer.buffer;
+import static org.lwjgl.opengl.GL11.*;
+import static org.lwjgl.opengl.GL12.GL_TEXTURE_MAX_LEVEL;
+
+import net.minecraft.client.GLAllocation;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.enums.MipmapType;
+import net.minecraft.client.render.texture.meta.TextureProperties;
+import net.minecraft.core.util.helper.Buffer;
+import org.jetbrains.annotations.Nullable;
+
+import java.awt.image.BufferedImage;
+import java.nio.ByteBuffer;
+
+public class Texture {
+	public static boolean debugMipmap = false;
+	protected static final boolean fixArtifacts = true;
+	
+	protected int id;
+
+	public void init() {
+
+	}
+
+	public boolean hasMeta(String key) {
+		return false;
+	}
+
+	public @Nullable <T> T getMeta(String key, Class<T> aClass) {
+		return null;
+	}
+
+	public <T> T getOrDefaultMeta(String key, T metaDefault, Class<T> aClass) {
+		return metaDefault;
+	}
+
+	public boolean generate() {
+		if(isGenerated()) {
+			return false;
+		}
+		
+		id = GLAllocation.generateTexture();
+		if(!isGenerated()) {
+			throw new RuntimeException("Texture not created!");
+		}
+		
+		return true;
+	}
+	
+	public boolean delete() {
+		if(!isGenerated()) {
+			return false;
+		}
+		GLAllocation.deleteTexture(id);
+		id = 0;
+		return true;
+	}
+	
+	public boolean bind() {
+		if(!isGenerated()) {
+			return false;
+		}
+		
+		glBindTexture(GL_TEXTURE_2D, id);
+		return true;
+	}
+
+	public void unbind() {
+		glBindTexture(GL_TEXTURE_2D, 0);
+	}
+
+	@Override
+	protected void finalize() throws Throwable {
+		super.finalize();
+		delete();
+	}
+
+	public boolean isGenerated() {
+		return id != 0;
+	}
+	
+	public int getWidth() {
+		return glGetTexLevelParameteri(GL_TEXTURE_2D, 0, GL_TEXTURE_WIDTH);
+	}
+	
+	public int getHeight() {
+		return glGetTexLevelParameteri(GL_TEXTURE_2D, 0, GL_TEXTURE_HEIGHT);
+	}
+	
+	public int id() {
+		return id;
+	}
+
+
+	public void setupTexture(BufferedImage image) {
+		boolean blurTexture = false;
+		boolean clampTexture = false;
+		boolean mipmap = false;
+		if (hasMeta("texture")) {
+			TextureProperties properties = getMeta("texture", TextureProperties.class);
+			blurTexture = properties.blur;
+			clampTexture = properties.clamp;
+			mipmap = properties.mipmap;
+		}
+		setupTexture(image, blurTexture, clampTexture, mipmap);
+	}
+
+	public void setupTexture(BufferedImage img, boolean blurTexture, boolean clampTexture, boolean mipmap) {
+		bind();
+
+
+
+		if(blurTexture) {
+			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
+			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
+		}else {
+			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
+			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
+		}
+
+		if(clampTexture) {
+			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
+			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
+		}else {
+			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
+			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
+		}
+
+		int w = img.getWidth();
+		int h = img.getHeight();
+
+		Buffer.put(img);
+		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
+
+		if(mipmap) {
+			Minecraft mc = Minecraft.getMinecraft(this);
+			generateMipmaps(buffer, img, mc.gameSettings.mipmapLevels.value, mc.gameSettings.mipmapType.value == MipmapType.SMOOTH);
+		}
+	}
+
+	protected void generateMipmaps(ByteBuffer buffer, BufferedImage image, int levels, boolean smooth) {
+		System.out.println("Generating Mipmaps...");
+
+		final int width = image.getWidth();
+		final int height = image.getHeight();
+
+		int[] data = new int[width * height];
+		int[] newData = null;
+
+		for(int x=0; x < width; x++) {
+			for(int y=0; y < height; y++) {
+				data[width * y + x] = image.getRGB(x, y);
+			}
+		}
+
+		if(fixArtifacts) {
+			for(int level = levels; level > 0; level--) {
+				int lod = (int) Math.pow(2, level);
+
+				int tilesX = width / lod;
+				int tilesY = height / lod;
+
+				for(int x = 0; x < tilesX; x++) {
+					for(int y = 0; y < tilesY; y++) {
+
+						Integer nonTransparentColor = null;
+
+						getColor: for(int i=0; i < lod; i++) {
+							for(int j=0; j < lod; j++) {
+								int x0 = x * lod + i;
+								int y0 = y * lod + j;
+
+								int color = data[width * y0 + x0];
+
+								if(((color >> 24) & 0xFF) > 0) {
+									nonTransparentColor = color;
+									break getColor;
+								}
+							}
+						}
+
+						if(nonTransparentColor != null) {
+							nonTransparentColor &= 0x00FFFFFF;
+
+							for(int i=0; i < lod; i++) {
+								for(int j=0; j < lod; j++) {
+									int x0 = x * lod + i;
+									int y0 = y * lod + j;
+
+									int color = data[width * y0 + x0];
+
+									if(((color >> 24) & 0xFF) == 0) {
+										data[width * y0 + x0] = nonTransparentColor;
+									}
+								}
+							}
+						}
+					}
+				}
+			}
+		}
+
+		int previousWidth = width;
+		int newWidth = width;
+		int newHeight = height;
+
+		for(int level = 0; level <= levels; level++) {
+			newData = new int[newWidth * newHeight];
+
+			for(int y = 0; y < newHeight; y++) {
+				for(int x = 0; x < newWidth; x++) {
+					int color;
+
+					if(level == 0) {
+						color = data[width * y + x];
+					}else {
+						int x1 = x << 1;
+						int y1 = y << 1;
+
+						if(smooth) {
+							int color0 = data[previousWidth * (y1 + 0) + (x1 + 0)];
+							int color1 = data[previousWidth * (y1 + 0) + (x1 + 1)];
+							int color2 = data[previousWidth * (y1 + 1) + (x1 + 0)];
+							int color3 = data[previousWidth * (y1 + 1) + (x1 + 1)];
+
+							color = blendColor(blendColor(color0, color1), blendColor(color2, color3));
+						}else {
+							color = data[previousWidth * y1 + x1];
+						}
+					}
+
+					newData[y * newWidth + x] = color;
+				}
+			}
+
+			buffer.position(0).limit(buffer.capacity());
+
+			for(int i=0; i < newData.length; i++) {
+				int color = newData[i];
+
+				buffer.put((byte) ((color >> 16) & 0xFF));
+				buffer.put((byte) ((color >>  8) & 0xFF));
+				buffer.put((byte) ((color >>  0) & 0xFF));
+				buffer.put((byte) ((color >> 24) & 0xFF));
+			}
+
+			buffer.limit(buffer.position()).flip();
+
+			glTexImage2D(GL_TEXTURE_2D, debugMipmap ? 0 : level, GL_RGBA, newWidth, newHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
+			if(!debugMipmap) {
+				glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAX_LEVEL, level);
+				glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_LINEAR);
+			}
+
+			data = newData;
+			previousWidth = newWidth;
+
+			newWidth /= 2;
+			newHeight /= 2;
+		}
+	}
+	protected int blendColor(int color0, int color1) {
+		int alpha0 = (color0 >> 24) & 0xFF;
+		int alpha1 = (color1 >> 24) & 0xFF;
+
+		int alphaAvg = (alpha0 + alpha1) / 2;
+
+		if(alpha0 == 0 && alpha1 == 0) {
+			alpha0 = 1;
+			alpha1 = 1;
+		}else {
+			if(alpha0 == 0) {
+				color0 = color1;
+				alphaAvg /= 2;
+			}
+			if(alpha1 == 0) {
+				color1 = color0;
+				alphaAvg /= 2;
+			}
+		}
+
+		int r0 = (color0 >> 16 & 0xFF) * alpha0;
+		int g0 = (color0 >>  8 & 0xFF) * alpha0;
+		int b0 = (color0 >>  0 & 0xFF) * alpha0;
+
+		int r1 = (color1 >> 16 & 0xFF) * alpha1;
+		int g1 = (color1 >>  8 & 0xFF) * alpha1;
+		int b1 = (color1 >>  0 & 0xFF) * alpha1;
+
+		int rAvg = (r0 + r1) / (alpha0 + alpha1);
+		int gAvg = (g0 + g1) / (alpha0 + alpha1);
+		int bAvg = (b0 + b1) / (alpha0 + alpha1);
+
+		return alphaAvg << 24 | rAvg << 16 | gAvg << 8 | bAvg;
+	}
+}
diff --git a/src/main/java/net/minecraft/client/render/texture/meta/AnimationProperties.java b/src/main/java/net/minecraft/client/render/texture/meta/AnimationProperties.java
new file mode 100644
index 000000000..6b7a68fea
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/texture/meta/AnimationProperties.java
@@ -0,0 +1,32 @@
+package net.minecraft.client.render.texture.meta;
+
+import org.jetbrains.annotations.Nullable;
+
+import java.util.List;
+
+public class AnimationProperties {
+    public final boolean interpolate;
+    public final boolean random;
+    public final int width;
+    public final int height;
+    public final int frametime;
+    public final @Nullable List<Frame> frames;
+    public AnimationProperties(boolean interpolate, boolean random, int width, int height, int frametime, @Nullable List<Frame> frames) {
+        this.interpolate = interpolate;
+        this.random = random;
+        this.width = width;
+        this.height = height;
+        this.frametime = frametime;
+        this.frames = frames;
+    }
+
+    public static class Frame {
+        public final int index;
+        public final int time;
+
+        public Frame(int index, int time) {
+            this.index = index;
+            this.time = time;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/texture/meta/AnimationPropertiesAdapter.java b/src/main/java/net/minecraft/client/render/texture/meta/AnimationPropertiesAdapter.java
new file mode 100644
index 000000000..1a744c5af
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/texture/meta/AnimationPropertiesAdapter.java
@@ -0,0 +1,72 @@
+package net.minecraft.client.render.texture.meta;
+
+import com.google.gson.JsonArray;
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+
+import java.lang.reflect.Type;
+import java.util.ArrayList;
+import java.util.List;
+
+public class AnimationPropertiesAdapter implements JsonDeserializer<AnimationProperties>, JsonSerializer<AnimationProperties> {
+    @Override
+    public AnimationProperties deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+        JsonObject obj = json.getAsJsonObject();
+        boolean interpolate = false;
+        boolean random = false;
+        int width = 1;
+        int height = 1;
+        int frametime = 1;
+        List< AnimationProperties.Frame > frames = null;
+
+        if (obj.has("interpolate")) {
+            interpolate = obj.get("interpolate").getAsBoolean();
+        }
+
+        if (obj.has("random")) {
+            random = obj.get("random").getAsBoolean();
+        }
+
+        if (obj.has("width")) {
+            width = obj.get("width").getAsInt();
+        }
+
+        if (obj.has("height")) {
+            height = obj.get("height").getAsInt();
+        }
+
+        if (obj.has("frametime")) {
+            frametime = obj.get("frametime").getAsInt();
+        }
+
+        if (obj.has("frames")) {
+            JsonArray array = obj.getAsJsonArray("frames");
+            frames = new ArrayList<>();
+            for (JsonElement e : array) {
+                if (e.isJsonPrimitive()) {
+                    frames.add(new AnimationProperties.Frame(e.getAsInt(), frametime));
+                    continue;
+                }
+                JsonObject frameObject = e.getAsJsonObject();
+                int index = frameObject.get("index").getAsInt();
+                int time = frametime;
+                if (frameObject.has("time")) {
+                    time = frameObject.get("time").getAsInt();
+                }
+                frames.add(new AnimationProperties.Frame(index, time));
+            }
+        }
+
+        return new AnimationProperties(interpolate, random, width, height, frametime, frames);
+    }
+
+    @Override
+    public JsonElement serialize(AnimationProperties src, Type typeOfSrc, JsonSerializationContext context) {
+        return null;
+    }
+}
